package com.hai.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.hai.common.exception.ErrorCode;
import com.hai.common.exception.ErrorHelp;
import com.hai.common.exception.SysCode;
import com.hai.entity.ApiMerchants;
import com.hai.entity.ApiOrderRecord;
import com.hai.entity.ApiProduct;
import com.hai.service.ApiMerchantsService;
import com.hai.service.ApiOpenService;
import com.hai.service.ApiOrderRecordService;
import com.hai.service.ApiProductService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.Map;

@Service("apiOpenService")
public class ApiOpenServiceImpl implements ApiOpenService {

    @Resource
    private ApiOrderRecordService apiOrderRecordService;

    @Resource
    private ApiMerchantsService apiMerchantsService;

    @Resource
    private ApiProductService apiProductService;

    @Override
    @Transactional(rollbackFor=Exception.class,isolation = Isolation.SERIALIZABLE,propagation= Propagation.REQUIRES_NEW)
    public JSONObject createOrder(JSONObject object) {

        Map<String, Object> orderMap = new HashMap<>();
        orderMap.put("sourceOrderNo" , object.getString("orderNo"));

        // 查询是否用重复订单
        ApiOrderRecord apiOrderRecord = apiOrderRecordService.queryOrderResult(orderMap);

        ApiMerchants apiMerchants = apiMerchantsService.findByMchId(object.getString("merchId"));

        if (apiOrderRecord != null) {
            throw ErrorHelp.genException(SysCode.System, ErrorCode.ORDER_ALREADY_EXISTS);
        }

        ApiProduct apiProduct = apiProductService.findById(object.getLong("goodsId"));
        // 当前账号余额是否可以充值当前金额
//        if (apiMerchants.getAmounts().compareTo(apiProduct.))


        return null;
    }
}
